package com.unionpay.acp.demo.cardAPI;
import org.apache.log4j.Logger;
import com.unionpay.acp.demo.DemoBase;
import com.unionpay.acp.sdk.*;
import java.util.HashMap;
import java.util.Map;

/**
 * 重要：联调测试时请仔细阅读注释！
 * <p>
 * 产品：签约支付<br>
 * 交易：签约短信<br>
 * 版权： 中国银联<br>
 * 声明：以下代码只是为了方便商户测试而提供的样例代码，商户可以根据自己需要，按照技术文档编写。该代码仅供参考，不提供编码，性能，规范性等方面的保障<br>
 */

public class Demo36_3_ContractPaySignSms {

    private final static Logger logger = Logger.getLogger(Demo36_3_ContractPaySignSms.class);

    public static void main(String[] args) {

        Map<String, String> contentData = new HashMap<String, String>();
        /*** 银联全渠道系统，产品参数，除了encoding自行选择外其他不需修改 ***/
        contentData.put("version", DemoBase.version); // 版本号
        contentData.put("encoding", DemoBase.encoding); // 字符集编码，可以使用UTF-8,GBK两种方式
        contentData.put("signMethod", SDKConfig.getConfig().getSignMethod()); // 签名方法// 目前只支持01-RSA方式证书加密
        contentData.put("txnType", "77"); // 交易类型
        contentData.put("txnSubType", "19"); // 交易子类型
        contentData.put("bizType", "000000"); // 默认：000000
        contentData.put("channelType", "07"); //渠道类型

        contentData.put("accessType", SDKConfig.getValueFromConfig("accessType"));
        contentData.put("merId", SDKConfig.getValueFromConfig("merId"));

        if ("1".equals(SDKConfig.getValueFromConfig("accessType"))) {
            contentData.put("acqInsCode", SDKConfig.getValueFromConfig("acqInsCode"));//接入类型为收单机构接入时需上送
            contentData.put("merCatCode", SDKConfig.getValueFromConfig("merCatCode"));//填写MCC码，接入类型为收单机构接入时需上送
            contentData.put("merName", SDKConfig.getValueFromConfig("merName"));//接入类型为收单机构接入时需上送
            contentData.put("merEnName", SDKConfig.getValueFromConfig("merEnName"));//接入类型为收单机构接入时需上送
            contentData.put("merAbbr", SDKConfig.getValueFromConfig("merAbbr"));//接入类型为收单机构接入时需上送
        }

        if ("2".equals(SDKConfig.getValueFromConfig("accessType"))) {
            //接入类型为平台类商户接入时需上送
            contentData.put("subMerId", SDKConfig.getValueFromConfig("subMerId"));//二级商户代码
            contentData.put("subMerName", SDKConfig.getValueFromConfig("subMerName"));//二级商户名称
            contentData.put("subMerAbbr", SDKConfig.getValueFromConfig("subMerAbbr")); //二级商户简称
        }
        contentData.put("orderId", DemoUtil.getOrderId()); // 商户订单号，8-40位数字字母，不能含“-”或“_”，可以自行定制规则,此处为演示方便默认取了个值
        contentData.put("txnTime", DemoUtil.getTxnTime()); // 订单发送时间，格式为YYYYMMDDhhmmss，必须取当前时间，否则会报txnTime无效,此处为演示方便默认取了个值
        //contentData.put("orderId", SDKConfig.getValueFromConfig("orderId")); // 商户订单号，8-40位数字字母，不能含“-”或“_”，可以自行定制规则
        //contentData.put("txnTime", SDKConfig.getValueFromConfig("txnTime")); // 订单发送时间，格式为YYYYMMDDhhmmss，必须取当前时间，否则会报txnTime无效

        Map<String, String> customerInfoMap = new HashMap<String, String>();
        customerInfoMap.put("certifTp", SDKConfig.getValueFromConfig("certifTp")); // 证件类型
        customerInfoMap.put("certifId", SDKConfig.getValueFromConfig("certifId")); // 证件号码
        customerInfoMap.put("customerNm", SDKConfig.getValueFromConfig("customerNm")); // 姓名
        customerInfoMap.put("smsCode", SDKConfig.getValueFromConfig("smsCode")); // 短信验证码
        customerInfoMap.put("pin", SDKConfig.getValueFromConfig("pin")); // 持卡人密码
        customerInfoMap.put("phoneNo", SDKConfig.getValueFromConfig("phoneNo")); // 手机号
        customerInfoMap.put("subCertifId", SDKConfig.getValueFromConfig("subCertifId")); // 身份证号后6位，当身份证最后一位是X时，上送X前面的6位数字


        // 请求方保留域，
        // 透传字段，查询、通知、对账文件中均会原样出现，如有需要请启用并修改自己希望透传的数据。
        // 出现部分特殊字符时可能影响解析，请按下面建议的方式填写：
        // 1. 如果能确定内容不会出现&={}[]"'等符号时，可以直接填写数据，建议的方法如下。
        // data.put("reqReserved", "透传信息1|透传信息2|透传信息3");
        // 2. 内容可能出现&={}[]"'符号时：
        // 1) 如果需要对账文件里能显示，可将字符替换成全角＆＝｛｝【】“‘字符（自己写代码，此处不演示）；
        // 2) 如果对账文件没有显示要求，可做一下base64（如下）。
        //    注意控制数据长度，实际传输的数据长度不能超过1024位。
        //    查询、通知等接口解析时使用new String(Base64.decodeBase64(reqReserved), DemoBase.encoding);解base64后再对数据做后续解析。
        //data.put("reqReserved", Base64.encodeBase64String("任意格式的信息都可以".toString().getBytes(DemoBase.encoding)));
        contentData.put("reqReserved", SDKConfig.getValueFromConfig("reqReserved"));//可选上送
        contentData.put("payAppId", SDKConfig.getValueFromConfig("payAppId"));// 支付工具代码,当支付工具接入时，必送


        //////////如果商户号开通了  商户对敏感信息加密的权限那么，需要对 卡号accNo加密使用：
        String useEncryptCertId = SDKConfig.getValueFromConfig("useEncryptCertId");
        String ctrlRule = SDKConfig.getValueFromConfig("ctrlRule");
        contentData.put("ctrlRule", ctrlRule);

        //根据卡号签约时，必送
        String accNo = SDKConfig.getValueFromConfig("accNo");
        if ("1".equals(useEncryptCertId)) {
            //如果 机构号 开通了对敏感信息加密的权限对卡号accNo,phoneNo加密使用如下：
            contentData.put("encryptCertId", AcpService.getEncryptCertId());
            String accNoEnc = AcpService.encryptData(accNo, DemoBase.encoding);
            // 国密算法
            //String accNoEnc = GmAcpService.encryptData(accNo, DemoBase.encoding);
            contentData.put("accNo", accNoEnc);

            String customerInfoStrEncrypt = AcpService.getCustomerInfoWithEncrypt(customerInfoMap, accNo, DemoBase.encoding);
            //String customerInfoStrEncrypt = GmAcpService.getCustomerInfoWithEncrypt(customerInfoMap, accNo, DemoBase.encoding);
            contentData.put("customerInfo", customerInfoStrEncrypt);

        } else {
            //如果机构号申请了对 敏感信息 不加密  对卡号accNo,phoneNo不加密
            contentData.put("accNo", accNo);
            String customerInfoStr = AcpService.getCustomerInfo(customerInfoMap, accNo, DemoBase.encoding);
            //String customerInfoStr = GmAcpService.getCustomerInfo(customerInfoMap, accNo, DemoBase.encoding);
            contentData.put("customerInfo", customerInfoStr);
        }

//        //根据token签约时，必送：trId、token
//        Map<String, String> tokenPayData = new HashMap<String, String>();
//        tokenPayData.put("token", SDKConfig.getValueFromConfig("token"));
//        tokenPayData.put("trId", SDKConfig.getValueFromConfig("trId"));
//        tokenPayData.put("tokenLevel", SDKConfig.getValueFromConfig("tokenLevel"));
//        tokenPayData.put("tokenBegin", SDKConfig.getValueFromConfig("tokenBegin"));
//        tokenPayData.put("tokenEnd", SDKConfig.getValueFromConfig("tokenEnd"));
//        tokenPayData.put("tokenType", SDKConfig.getValueFromConfig("tokenType"));
//        contentData.put("tokenPayData", SDKUtil.coverMap2String(tokenPayData));


        /**对请求参数进行签名并发送http post请求，接收同步应答报文**/
        Map<String, String> reqData = AcpService.sign(contentData, DemoBase.encoding); //报文中certId,signature的值是在signData方法中获取并自动赋值的，只要证书配置正确即可。
        String requestBackUrl = SDKConfig.getConfig().getBackRequestUrl(); //交易请求url从配置文件读取对应属性文件acp_sdk.properties中的 acpsdk.backTransUrl

        Map<String, String> rspData = AcpService.post(reqData, requestBackUrl, DemoBase.encoding);  //发送请求报文并接受同步应答（默认连接超时时间30秒，读取返回结果超时时间30秒）;这里调用signData之后，调用submitUrl之前不能对submitFromData中的键值对做任何修改，如果修改会导致验签不通过
        /**对应答码的处理，请根据您的业务逻辑来编写程序,以下应答码处理逻辑仅供参考------------->**/
        //应答码规范参考open.unionpay.com帮助中心 下载  产品接口规范  《平台接入接口规范-第5部分-附录》
        if (!rspData.isEmpty()) {
            if (AcpService.validate(rspData, DemoBase.encoding)) {
                logger.info("验证签名成功");
                String respCode = rspData.get("respCode");
                if (("00").equals(respCode)) {
                    //交易已受理(不代表交易已成功），等待接收后台通知确定交易成功，也可以主动发起 查询交易确定交易状态。
                    logger.warn("交易受理成功");
                } else if (("03").equals(respCode) ||
                        ("04").equals(respCode) ||
                        ("05").equals(respCode) ||
                        ("01").equals(respCode) ||
                        ("12").equals(respCode) ||
                        ("60").equals(respCode)) {
                    //后续需发起交易状态查询交易确定交易状态。
                    logger.warn("请稍后查询");
                } else {
                    //其他应答码为失败请排查原因
                    logger.warn("失败：" + rspData.get("respMsg"));
                }
            } else {
                logger.error("验证签名失败");
                //TODO 检查验证签名失败的原因
            }
        } else {
            //未返回正确的http状态
            logger.error("未获取到返回报文或返回http状态码非200");
        }

    }

}
